SystemOrganization addCategory: #'Slot-Class'!
SystemOrganization addCategory: #'Slot-ClassBuilder'!
SystemOrganization addCategory: #'Slot-Error'!
SystemOrganization addCategory: #'Slot-Layout'!
SystemOrganization addCategory: #'Slot-Layout-Test'!
SystemOrganization addCategory: #'Slot-LayoutBuilder'!
SystemOrganization addCategory: #'Slot-Traits'!
SystemOrganization addCategory: #'Slot-Traits-Test'!
SystemOrganization addCategory: #'Slot-Slot'!
SystemOrganization addCategory: #'Slot-Slot-Test'!
SystemOrganization addCategory: #'Slot-Slot-Modifier'!
SystemOrganization addCategory: #'Slot-Transformation'!

!TraitTransformation methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 23:03'!
composeWithLayout: aLayout
	^ subject composeWithLayout: aLayout! !

!ByteString methodsFor: '*Slot' stamp: 'ToonVerwaest 4/1/2011 03:57'!
asSlot
	^ self asSymbol asSlot! !

SlotObject subclass: #ActiveField
	instanceVariableNames: 'value slot mySelf listeners'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Slot'!

!ActiveField class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:09'!
slot: aSlot self: anObject
	^ (self new)
		mySelf: anObject;
		slot: aSlot;
		yourself! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:29'!
= other
	^ value = other! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: value! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:41'!
for: anInstance notify: anObject
	|aBlockOrSlot|
	aBlockOrSlot := anObject.
		
	aBlockOrSlot isSymbol
		ifTrue: [	
			aBlockOrSlot := anInstance class layout 
									atName: aBlockOrSlot ifAbsent: [aBlockOrSlot]].
	
	(aBlockOrSlot isKindOf: Slot)
		ifTrue: [ 
			^ listeners at: anInstance 
			     		  put: [:val| aBlockOrSlot write: val to: anInstance]].
				
	aBlockOrSlot isSymbol
		ifTrue: [	
			(anInstance class lookupSelector: aBlockOrSlot)
				ifNotNilDo:[ :aMethod| aBlockOrSlot := aMethod]].
								
	aBlockOrSlot isCompiledMethod
		ifTrue: [
			^ listeners at: anInstance 
			     		  put: [:val| anInstance withArgs: {val} executeMethod: aBlockOrSlot]].
				
				
	listeners at: anInstance put: aBlockOrSlot.
		
	
	! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:07'!
initialize
	listeners := WeakKeyDictionary new.! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
mySelf
	^ mySelf! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
mySelf: anObject
	mySelf := anObject! !

!ActiveField methodsFor: 'accessing' stamp: 'CamilloBruni 3/24/2011 23:06'!
slot
	^ slot! !

!ActiveField methodsFor: 'accessing' stamp: 'CamilloBruni 3/24/2011 23:06'!
slot: anObject
	slot := anObject! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
value
	^ value! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:15'!
value: anObject 
	value := anObject.
	listeners do: [ :aBlock|
		aBlock value: value].
	^ anObject! !

!TraitComposition methodsFor: '*Slot' stamp: 'ToonVerwaest 4/2/2011 20:49'!
composeWithLayout: aLayout
	| result |
	result := aLayout.
	transformations do: [ :aTransformation |
		result := aTransformation composeWithLayout: result ].
	^ result! !

!CompiledMethod class methodsFor: '*Slot' stamp: 'ToonVerwaest 3/28/2011 20:30'!
newInstanceFrom: oldInstance variable: variable size: instSize map: map
	"Create a new instance of the receiver based on the given old instance.
	The supplied map contains a mapping of the old instVar names into
	the receiver's instVars"
	| new |
	new := self newFrom: oldInstance.
	1 to: instSize do: 
		[:offset | map isArray
				ifTrue: [ |index|
					index := map at: offset.
					index > 0 ifTrue: [
						new
							instVarAt: offset
							put: (oldInstance instVarAt: index)]]
				ifFalse: [ |slotModification|
					slotModification := map modificationAt: offset.
					slotModification migrateAt: offset to: new from: oldInstance ]].
	^new! !

!Symbol methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 16:23'!
=> aSlot
	aSlot isBehavior
		ifTrue: [ ^ aSlot named: self].
	^ aSlot name: self;
		yourself! !

!Symbol methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:35'!
asSlot
	^ Slot named: self.! !

!AddClassChange class methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 19:40'!
definitionPatterns
	^ #('`@superclass subclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass subclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableByteSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableByteSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableWordSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableWordSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass weakSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass weakSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass subclass: `#className layout: `@layoutClass slots: `@slots classSlots: `@classSlots globals: `#globals category: `#category'
		'`@superclass subclass: `#className layout: `@layoutClass uses: `@traitComposition slots: `@slots classSlots: `@classSlots globals: `#globals category: `#category')
		gather: [ :each | 
			Array with: each 
				with: ((each copyReplaceAll: 'instanceVariableNames:' with: 'slots:') copyReplaceAll: '`#instanceVariableNames' with: '`@slots')
				with: (each copyReplaceAll: '`@superclass' with: 'ProtoObject') , '. `className superclass: `@superclass']! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:59'!
name: className inEnvironment: env subclassOf: newSuper type: type slots: slots classVariableNames: classVarString poolDictionaries: poolString category: category
	"Define a new class in the given environment"
	^self 
		name: className 
		inEnvironment: env 
		subclassOf: newSuper 
		type: type 
		slots: slots 
		classVariableNames: classVarString 
		poolDictionaries: poolString 
		category: category
		unsafe: false! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 20:27'!
name: className inEnvironment: env subclassOf: newSuper type: type slots: slots classVariableNames: classVarString poolDictionaries: poolString category: category unsafe: unsafe
	"Define a new class in the given environment.
	If unsafe is true do not run any validation checks.
	This facility is provided to implement important system changes."

	| oldClass instVarNames classVars copyOfOldClass copyOfOldTraitComposition copyOfOldClassTraitComposition newClass |
	environ := env.
	
	
	instVarNames := Array new: slots size.
	slots withIndexDo: [:slot :index|  instVarNames at: index put: slot name].
	
	classVars := (Scanner new scanFieldNames: classVarString) collect: [ :x | x asSymbol ].	"Validate the proposed name"
		
	unsafe
		ifFalse: [ 
			(self validateClassName: className)
				ifFalse: [ ^ nil ] ].
			
	oldClass := env at: className ifAbsent: [ nil ].
	
	oldClass isBehavior
		ifFalse: [ oldClass := nil ]
		ifTrue: [ 
			copyOfOldClass := oldClass copy.
			copyOfOldClass superclass addSubclass: copyOfOldClass.
			copyOfOldClass
				ifNotNil: [ 
					oldClass hasTraitComposition
						ifTrue: [ copyOfOldTraitComposition := oldClass traitComposition copyTraitExpression ].
					oldClass class hasTraitComposition
						ifTrue: [ copyOfOldClassTraitComposition := oldClass class traitComposition copyTraitExpression ] ] ].	"Already checked in #validateClassName:"
					
	[ 
	| newCategory oldCategory needNew force organization |
	unsafe
		ifFalse: [ 
			"Run validation checks so we know that we have a good chance for recompilation"
			(self validateSuperclass: newSuper forSubclass: oldClass)
				ifFalse: [ ^ nil ].
			(self validateInstvars: instVarNames from: oldClass forSuper: newSuper)
				ifFalse: [ ^ nil ].
			(self validateClassvars: classVars from: oldClass forSuper: newSuper)
				ifFalse: [ ^ nil ].
			"should go via layout"
			(self
				validateSubclassFormat: type
				from: oldClass
				forSuper: newSuper
				extra: instVarNames size)
				ifFalse: [ ^ nil ] ].	"See if we need a new subclass"
				
	needNew := self
		needsSubclassOf: newSuper
		type: type
		instanceVariables: instVarNames
		from: oldClass.
		
	needNew == nil
		ifTrue: [ ^ nil ].	"some error"
			
	(needNew and: [ unsafe not ])
		ifTrue: [ 
			"Make sure we don't redefine any dangerous classes"
			(self tooDangerousClasses includes: oldClass name)
				ifTrue: [ self error: oldClass name , ' cannot be changed' ].	"Check if the receiver should not be redefined"
					
			(oldClass ~~ nil and: [ oldClass shouldNotBeRedefined ])
				ifTrue: [ self notify: oldClass name asText allBold , ' should not be redefined. \Proceed to store over it.' withCRs ] ].
	needNew
		ifTrue: [ 
			"Create the new class"
			newClass := self
				newSubclassOf: newSuper
				type: type
				slots: slots
				from: oldClass.
			newClass == nil
				ifTrue: [ ^ nil ].	"Some error"
			newClass setName: className ]
		ifFalse: [ 
			"Reuse the old class"
			newClass := oldClass ].	"Install the class variables and pool dictionaries... "
			
	force := (newClass declare: classVarString) | (newClass sharing: poolString).	"... classify ..."
	newCategory := category asSymbol.
	organization := environ ifNotNil: [ environ organization ].
	oldClass isNil
		ifFalse: [ oldCategory := (organization categoryOfElement: oldClass name) asSymbol ].
		
	organization classify: newClass name under: newCategory.
	newClass environment: environ.	"... recompile ..."
		
	newClass := self
		recompile: force
		from: oldClass
		to: newClass
		mutate: false.	"... export if not yet done ..."
			
	(environ at: newClass name ifAbsent: [ nil ]) == newClass
		ifFalse: [ 
			environ at: newClass name put: newClass.
			Smalltalk globals flushClassNameCache ].	"... set trait composition..."
			
	copyOfOldTraitComposition ifNotNil: [ newClass setTraitComposition: copyOfOldTraitComposition ].
	copyOfOldClassTraitComposition ifNotNil: [ newClass class setTraitComposition: copyOfOldClassTraitComposition ].
	newClass doneCompiling.	"... notify interested clients ..."
		
	oldClass isNil
		ifTrue: [ 
			SystemChangeNotifier uniqueInstance classAdded: newClass inCategory: newCategory.
			^ newClass ].
		
	newCategory ~= oldCategory
		ifTrue: [ SystemChangeNotifier uniqueInstance class: newClass recategorizedFrom: oldCategory to: category ]
		ifFalse: [ SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: copyOfOldClass to: newClass ] ]
		ensure: [ 
			copyOfOldClass ifNotNil: [ copyOfOldClass superclass removeSubclass: copyOfOldClass ].
			Behavior flushObsoleteSubclasses ].
		
	^ newClass! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:35'!
newSubclassOf: newSuper type: type instanceVariables: instVars from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: instVars size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil
		ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass shallowCopy].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		setInstVarNames: instVars;
		initializeLayout. " build the default layout with normal slots"

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].		
		self recordClass: oldClass replacedBy: newClass].

	(oldClass == nil or:[oldClass isObsolete not]) 
		ifTrue:[newSuper addSubclass: newClass]
		ifFalse:[newSuper addObsoleteSubclass: newClass].

	^newClass! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:25'!
newSubclassOf: newSuper type: type slots: slots from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: slots size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil 
		ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass shallowCopy].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		initializeLayoutWithSlots: slots.

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].		
		self recordClass: oldClass replacedBy: newClass.
	].

	(oldClass == nil or:[oldClass isObsolete not]) 
		ifTrue:[newSuper addSubclass: newClass]
		ifFalse:[newSuper addObsoleteSubclass: newClass].

	^newClass! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:42'!
privateNewSubclassOf: newSuper
	"Create a new meta and non-meta subclass of newSuper"
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newSuperMeta newMeta |
	
	newSuperMeta := newSuper ifNil:[Class] ifNotNil:[newSuper class].
	newMeta := Metaclass new.
	
	newMeta 
		superclass: newSuperMeta 
		methodDictionary: MethodDictionary new 
		format: newSuperMeta format;
		initializeLayout. " build the default layout with normal slots"
		
	^newMeta new
! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:42'!
privateNewSubclassOf: newSuper from: oldClass
	"Create a new meta and non-meta subclass of newSuper using oldClass as template"
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newSuperMeta oldMeta newMeta |
	oldClass ifNil:[^self privateNewSubclassOf: newSuper].
	newSuperMeta := newSuper ifNil:[Class] ifNotNil:[newSuper class].
	
	oldMeta := oldClass class.
	newMeta := oldMeta shallowCopy.
	
	newMeta 
		superclass: newSuperMeta
		methodDictionary: MethodDictionary new
		format: (self computeFormat: oldMeta typeOfClass 
					instSize: oldMeta instVarNames size 
					forSuper: newSuperMeta
					ccIndex: 0);
		setInstVarNames: oldMeta instVarNames;
		organization: oldMeta organization;
		initializeLayout. " build the default layout with normal slots"
		
	"Recompile the meta class"
	oldMeta hasMethods 
		ifTrue:[newMeta compileAllFrom: oldMeta].
		
	"Record the meta class change"
	self recordClass: oldMeta replacedBy: newMeta.
	
	"And create a new instance"
	^ newMeta adoptInstance: oldClass from: oldMeta! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: newSuper
	subclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class."
	^self 
		name: t
		inEnvironment: newSuper environment
		subclassOf: newSuper
		type: newSuper typeOfClass
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	variableByteSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable byte-sized nonpointer variables."
	| oldClassOrNil actualType |
	(aClass instSize > 0)
		ifTrue: [^self error: 'cannot make a byte subclass of a class with named fields'].
	(aClass isVariable and: [aClass isWords])
		ifTrue: [^self error: 'cannot make a byte subclass of a class with word fields'].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: 'cannot make a byte subclass of a class with pointer fields'].
	oldClassOrNil := aClass environment at: t ifAbsent:[nil].
	actualType := (oldClassOrNil notNil
				   and: [oldClassOrNil typeOfClass == #compiledMethod])
					ifTrue: [#compiledMethod]
					ifFalse: [#bytes].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: actualType
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	variableSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable pointer variables."
	aClass isBits 
		ifTrue: [^self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #variable
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	variableWordSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable word-sized nonpointer variables."
	(aClass instSize > 0)
		ifTrue: [^self error: 'cannot make a word subclass of a class with named fields'].
	(aClass isVariable and: [aClass isBytes])
		ifTrue: [^self error: 'cannot make a word subclass of a class with byte fields'].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: 'cannot make a word subclass of a class with pointer fields'].

	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #words
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	weakSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver) in which the subclass is to 
	have weak indexable pointer variables."
	aClass isBits 
		ifTrue: [^self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #weak
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

Error subclass: #InvalidType
	instanceVariableNames: 'has expected denied'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Error'!

!InvalidType class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 14:44'!
has: instance denied: aClass
	^ self new
		has: instance;
		denied: aClass;
		yourself! !

!InvalidType class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 14:44'!
has: instance expected: aClass
	^ self new
		has: instance;
		expected: aClass;
		yourself! !

!InvalidType methodsFor: 'accessing' stamp: 'CAmi 3/14/2011 23:51'!
bla
	|a|
	a := messageText.
	a := tag.
	a := self instVarAt: 1.
	^ a! !

!InvalidType methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 17:04'!
defaultAction
	
	UnhandledError signalForException: self! !

!InvalidType methodsFor: 'accessing' stamp: 'CamilloBruni 3/22/2011 18:50'!
denied
	^ denied! !

!InvalidType methodsFor: 'accessing' stamp: 'CamilloBruni 3/22/2011 18:50'!
denied: aClass
	denied := aClass! !

!InvalidType methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 14:43'!
description
	denied ifNil: [
		^ 'Expected type ', expected name, ' but got instance of ', has class name].
	^ 'Got banned type ', denied name.! !

!InvalidType methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 16:59'!
expected
	^ expected! !

!InvalidType methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 16:59'!
expected: aClass
	expected := aClass! !

!InvalidType methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 16:59'!
has
	^ has! !

!InvalidType methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 16:59'!
has: anObject
	has := anObject.! !

Error subclass: #SlotNotFound
	instanceVariableNames: 'name targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Error'!

!SlotNotFound class methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 18:53'!
signalForName: aSymbol
	self new
		name: aSymbol;
		signal! !

!SlotNotFound class methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 18:55'!
signalForName: aSymbol inClass: aClass
	self new
		name: aSymbol;
		targetClass: aClass;
		signal! !

!SlotNotFound methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:22'!
messageText
	^ 'Slot ''', name asString, ''' not found', (targetClass ifNil: [''] ifNotNil:[' in ', targetClass name])! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
name
	^ name! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
name: anObject
	name := anObject! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:55'!
targetClass
	^ targetClass! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
targetClass: aClass
	targetClass := aClass! !

!TraitDescription methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 23:04'!
composeWithLayout: aLayout
	" Standard traits don't have any state "
	^ aLayout! !

Exception subclass: #ClassModificationConflict
	instanceVariableNames: 'modification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModificationConflict methodsFor: 'exceptiondescription' stamp: 'ToonVerwaest 3/21/2011 01:12'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	UnhandledError signalForException: self! !

!ClassModificationConflict methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:13'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

ClassModificationConflict subclass: #PrimitiveTypeConflict
	instanceVariableNames: 'layout subType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout
	^ layout! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout: anObject
	layout := anObject! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:30'!
messageText
	^ 'Class with ', layout class name, ' cannot be extended as ', subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType
	^ subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType: anObject
	subType := anObject! !

ClassModificationConflict subclass: #SlotDuplicationConflict
	instanceVariableNames: 'newSlot oldSlot host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host
	^ host! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host: anObject
	host := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:17'!
messageText
	^ 'Slot #''', oldSlot name, ''' appeared twice in ', host name! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot
	^ newSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot: anObject
	newSlot := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot
	^ oldSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot: anObject
	oldSlot := anObject! !

IdentitySet subclass: #HotSet
	instanceVariableNames: 'oppositeSlot type myself'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Slot'!

!HotSet methodsFor: 'adding' stamp: 'CamilloBruni 3/10/2011 17:36'!
add: newObject
	newObject ensureType: type.
	super add: newObject.
	oppositeSlot add: myself to: newObject.! !

!HotSet methodsFor: 'adding' stamp: 'CamilloBruni 3/10/2011 14:49'!
addSilently: newObject
	^ super add: newObject.! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 14:43'!
myself
	^ myself! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 14:44'!
myself: anObject
	myself := anObject.! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/4/2011 14:58'!
oppositeSlot
	^ oppositeSlot! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/4/2011 14:58'!
oppositeSlot: aSlot
	oppositeSlot := aSlot.! !

!HotSet methodsFor: 'removing' stamp: 'CamilloBruni 3/10/2011 14:43'!
remove: oldObject ifAbsent: aBlock
	| anObject |
	anObject := super remove: oldObject 
			ifAbsent: [ ^ aBlock value].
	oppositeSlot remove: myself from: oldObject.
	^ anObject.! !

!HotSet methodsFor: 'removing' stamp: 'CamilloBruni 3/10/2011 14:51'!
removeAll
	self do: [ :each|	
		oppositeSlot remove: myself from: each].
	^ super removeAll.! !

!HotSet methodsFor: 'removing' stamp: 'CamilloBruni 3/24/2011 14:49'!
removeSilently: oldObject
	"don't trigger updates"
	^  super remove: oldObject ! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 16:49'!
type: aType
	type := aType! !

TestCase subclass: #LayoutTest
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

LayoutTest subclass: #BitsLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

!BitsLayoutTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:37'!
isAbstract
	^ self = BitsLayoutTest! !

!BitsLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:03'!
layoutClass
	^ BitsLayout! !

!BitsLayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:40'!
testFixedSize
	self assert: layout fieldSize = 0! !

BitsLayoutTest subclass: #ByteLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

!ByteLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:05'!
layoutClass
	^ ByteLayout! !

BitsLayoutTest subclass: #WordLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

!WordLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:05'!
layoutClass
	^ WordLayout! !

!LayoutTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:37'!
isAbstract
	^ self = LayoutTest! !

!LayoutTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:36'!
shouldInheritSelectors
	^ true! !

!LayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:03'!
layoutClass
	^ Layout! !

!LayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:19'!
newLayoutInstance
	^ self layoutClass new! !

!LayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:19'!
setUp
	super setUp.
	layout := self newLayoutInstance.! !

LayoutTest subclass: #LayoutWithSlotsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

!LayoutWithSlotsTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:37'!
isAbstract
	^ self = LayoutWithSlotsTest! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:02'!
layoutClass
	^ LayoutWithSlots! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:01'!
newLayoutInstance
	|instance|
	instance := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		builder slot: (#field1 => Slot).
	].
	^ instance! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/7/2011 12:11'!
testAtName
	| slots |
	layout := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
		builder slot: (#c => Slot).
	].

	slots := layout allSlots.
	
	self assert: (layout resolveSlot: #a) == (slots at: 1).
	self assert: (layout resolveSlot: #b) == (slots at: 2).
	self assert: (layout resolveSlot: #c) == (slots at: 3).	! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:03'!
testAtNameIfAbsent
	|slots|
	layout := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].
	slots := layout allSlots.
	
	self assert: (layout atName: #a ifAbsent: [ #none ]) == (slots at: 1).
	self assert: (layout atName: #b ifAbsent: [ #none ] ) == (slots at: 2).
	
	self assert: (layout atName: #c ifAbsent: [ #none ]) == #none.
	self assert: (layout atName: #d ifAbsent: [ #none ] ) == #none.! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:04'!
testAtPut
	| slotA slotB slotC slots|
	layout := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		slotA := builder slot: (#a => Slot).
		slotB := builder slot: (#b => Slot).
		slotC := builder slot: (#c => Slot).
	].

	slots := layout allSlots.
	
	self assert: slotA index = 1.
	self assert: (slots at: 1) == slotA.
	
	self assert: slotB index = 2.
	self assert: (slots at: 2) == slotB.
	
	self assert: slotC index = 3.
	self assert: (slots at: 3) == slotC.! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:02'!
testFieldSize
	self assert: layout fieldSize = 1.
	
	layout := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].
	self assert: layout fieldSize = 2.! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:02'!
testIncludesName
	layout := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].

	self assert: (layout includesName: #a).
	self assert: (layout includesName: #b).
	self deny: (layout includesName: #c).
	self deny: (layout includesName: #d).! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:03'!
testSlotIndexes
	|slot1 alias1 slot2|
	
	layout := SlotLayoutBuilder make: [ :builder|
		builder scope: Object layout slotScope.
		builder layout: self layoutClass.
		slot1 := builder slot: (#field1 => Slot).
		alias1 := builder slot: (#alias1 => AliasSlot alias: #field2).
		slot2 := builder slot: (#field2 => Slot).
	].

	self assert: slot1 index = 1.
	self assert: slot2 index = 2.
	self assert: alias1 index = 2.! !

LayoutWithSlotsTest subclass: #ObjectLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

!ObjectLayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:21'!
layoutClass
	^ PointerLayout! !

LayoutWithSlotsTest subclass: #VariableLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout-Test'!

!VariableLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:05'!
layoutClass
	^ VariableLayout! !

TestCase subclass: #SlotLayoutBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-LayoutBuilder'!

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:39'!
builderClass
	^ SlotLayoutBuilder! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:06'!
testBasicByteLayout
	self should: [
			self builderClass makeByte: [ :builder|
				builder scope: Object layout slotScope.
				builder slot: (#a => Slot).
			]]
		raise: Error.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:08'!
testBasicLayoutProperty
	| layout |
	self fail.
	layout := self builderClass makeVariable: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => Slot property).
		builder slot: (#b => Slot).
	].! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:03'!
testBasicObjectLayout
	| layout slots|
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].

	slots := layout allSlots.
	
	self assert:(layout isKindOf: PointerLayout).
	
	self assert: slots size = 2.
	self assert: layout fieldSize = 2.
	
	self assert: (slots at: 1) name = #a.
	self assert: (slots at: 2) name = #b.
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:03'!
testBasicVariableLayout
	| layout slots|
	layout := self builderClass makeVariable: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].

	slots := layout allSlots.
	self assert:(layout isKindOf: VariableLayout).
	
	self assert: slots size = 2.
	self assert: layout fieldSize = 2.
	
	self assert: (slots at: 1) name = #a.
	self assert: (slots at: 2) name = #b.
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:00'!
testBasicWordLayout
	self should: [
			self builderClass makeWord: [ :builder|
				builder slot: (#a => Slot).
			]]
		raise: Error.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 17:04'!
testBitAndPropertySlots
	| layout slots |
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => BitSlot).
		builder slot: (#b => PropertySlot).
	].
	
	slots := layout allSlots.
	
	self assert: slots size = 4.
	self assert: layout fieldSize = 2.

	self assert: ((slots at: 1) isKindOf: BitFieldHolderSlot).
	self assert: ((slots at: 2) isKindOf: PropertyHolderSlot).
	self assert: ((slots at: 3) isKindOf: BitSlot).
	self assert: ((slots at: 4) isKindOf: PropertySlot).
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.
	self assert: (slots at: 3) index = 2.
	self assert: (slots at: 4) index = 3.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 14:07'!
testBitSlots
	| layout slots |
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => BitSlot).
		builder slot: (#b => BitSlot).
	].

	slots := layout allSlots.
	
	self assert: layout fieldSize = 1.
	self assert: slots size = 3.
	

	self assert: ((slots at: 1) isKindOf: BitFieldHolderSlot).
	self assert: ((slots at: 2) isKindOf: BitSlot).
	self assert: ((slots at: 3) isKindOf: BitSlot).
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.
	self assert: (slots at: 3) index = 2.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 14:31'!
testBitSlotsOverflow
	| layout slots bitFieldHolder|
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		1 to: 40 do: [:index| 
			builder slot: (('bit_',index asString) asSymbol => BitSlot)]
	].
	
	slots := layout allSlots.
	
	self assert: slots size = (40 + 2).
	self assert: layout fieldSize = 2.
	
	bitFieldHolder := slots at: 1.
	self assert: (bitFieldHolder isKindOf: BitFieldHolderSlot).
	self assert: bitFieldHolder index = 1.
	self assert: bitFieldHolder isFull.

	bitFieldHolder := slots at: 2.
	self assert: (bitFieldHolder isKindOf: BitFieldHolderSlot).
	self assert: bitFieldHolder index = 2.
	self deny: bitFieldHolder isFull.
	
	3 to: 32 do: [:index| |slot|
		slot := slots at: index.
		self assert: (slot isKindOf: BitSlot).
		self assert: slot index = 2 ].
	
	33 to: 42 do: [:index| |slot|
		slot := slots at: index.
		self assert: (slot isKindOf: BitSlot).
		self assert: slot index = 3 ].! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:43'!
testDuplicateSlot
	
	self should: [
		 self builderClass make: [ :builder|
				builder scope: Object layout slotScope.
				builder slot: #AAA.
				builder slot: #AAA.
			]]
		raise: SlotDuplicationConflict.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:38'!
testParentDuplicateSlots
	| parentLayout |
	
	parentLayout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#b => Slot).
	].

	self should: [self builderClass make: [ :builder|
			builder scope: parentLayout slotScope.
			builder slot: (#b => Slot).
		]]
		raise: SlotDuplicationConflict.
		! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 16:55'!
testParentPropertySlots
	| layout parentLayout slots |
	parentLayout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: #a1.
		builder slot: (#b => PropertySlot).
		builder slot: #a2.
	].

	layout := self builderClass make: [ :builder|
		builder scope: parentLayout slotScope.
		builder slot: (#c => PropertySlot).
	].

	slots := layout allSlots.
	
	self assert: layout fieldSize = 3.
	self assert: slots size = 5.
	
	self assert: ((slots at: 1) isKindOf: PropertyHolderSlot).
	self assert: ((slots at: 2) isKindOf: Slot).
	self assert: ((slots at: 3) isKindOf: PropertySlot).
	self assert: ((slots at: 4) isKindOf: Slot).
	self assert: ((slots at: 5) isKindOf: PropertySlot).! !

TestCase subclass: #SlotTest
	instanceVariableNames: 'slotObject layout slotObjectClass slot slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Slot-Test'!

!SlotTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:05'!
shouldInheritSelectors
	^ true! !

!SlotTest methodsFor: 'converting' stamp: 'CamilloBruni 4/4/2011 15:40'!
assertSlotAt: index named: name
	self assert: (slots at: index) name = name.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/20/2011 15:56'!
newTestObjectInstance
	^ self slotTestObjectClass new.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 4/4/2011 15:36'!
prepareTestObjectClass
	slotObjectClass initialize.
	! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 4/4/2011 17:28'!
setUp
	slotObjectClass := self slotTestObjectClass.
	self prepareTestObjectClass.
	slotObject := self newTestObjectInstance.
	layout := slotObjectClass layout.
	slots := layout allSlots.
	slot := slots at: 4.! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:47'!
slot
	^ slots at: 4! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 17:42'!
slot1
	^  slots at: 1! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 17:42'!
slot2
	^  slots at: 2! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 17:42'!
slot3
	^  slots at: 3! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 15:44'!
slotClass
	^ Slot! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 15:51'!
slotTestObjectClass
	^ SlotTestObject! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 15:38'!
testIndex
	self assert: self slot index = 4.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 16:21'!
testLayout
	self assertSlotAt: 1 named: #field1.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 16:02'!
testRead
	slotObject field: 2.
	self assert: slotObject field = 2.
	self assert: (self slot read: slotObject) = 2.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 15:39'!
testSize
	self assert: self slot size = 1.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 15:56'!
testWriteTo
	|instance|
	instance :=  (self slotTestObjectClass new).
	
	self assert: slotObject field = nil.
	self slot write: instance to: slotObject.
	self assert: slotObject field = instance.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

!AddTraitChange class methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 19:08'!
definitionPatterns
	^ #(
		'Trait named: `#traitName uses: `@traitComposition category: `#category'
		'StatefulTrait named: `#traitName layout: `@layout slots: `@slots uses: `@traitComposition category: `#category')! !

Object subclass: #AbstractClassBuilderClient
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractClassBuilderClient class methodsFor: 'building' stamp: 'ToonVerwaest 3/22/2011 19:12'!
make: aBlock
	| builder |
	builder := self new builder.
	aBlock value: builder.
	^ builder build! !

!AbstractClassBuilderClient methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:42'!
builder
	^ builder! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:43'!
classAdded: aClass inCategory: aCategory
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:44'!
classAt: aName ifAbsent: aBlock
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'traits' stamp: 'ToonVerwaest 4/2/2011 20:51'!
copyTraitCompositionFrom: old to: new
	self installTraitComposition: old traitComposition copyTraitExpression on: new.
		! !

!AbstractClassBuilderClient methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:45'!
environment: anEnvironment
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/22/2011 17:43'!
initialize
	builder := SlotClassBuilder new.
	builder client: self! !

!AbstractClassBuilderClient methodsFor: 'traits' stamp: 'ToonVerwaest 4/2/2011 23:47'!
installTraitComposition: aTraitComposition on: aClass
	self flag: 'Should probably send something else to test'.
	aTraitComposition == NilTraitComposition instance
		ifTrue: [ aClass setTraitComposition: {} asTraitComposition ]
		ifFalse: [ aClass setTraitComposition: aTraitComposition ]
		
	! !

!AbstractClassBuilderClient methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:44'!
recategorize: aClass to: aCategory
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'CamilloBruni 3/29/2011 11:23'!
superclassChangedOf: aClass to: newClass by: classModification
	self subclassResponsibility.! !

AbstractClassBuilderClient subclass: #AnonymousClassBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:45'!
classAdded: aClass inCategory: aCategory! !

!AnonymousClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
classAt: aName ifAbsent: aBlock
	^ aBlock value! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
environment: anEnvironment! !

!AnonymousClassBuilder methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:46'!
recategorize: aClass to: aCategory! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'CamilloBruni 3/29/2011 11:23'!
superclassChangedOf: aClass to: newClass by: classModification! !

AbstractClassBuilderClient subclass: #PharoClassInstaller
	instanceVariableNames: 'environment instanceModification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:09'!
classAdded: aClass inCategory: aCategory
	" Install the new class in the system "
	environment at: aClass name put: aClass.
	environment flushClassNameCache.
	" Update the system's organization "
	environment organization classify: aClass name under: aCategory.
	self systemChangeNotifier classAdded: aClass inCategory: aCategory.
	" Inform superclass of new subclass "
	aClass superclass addSubclass: aClass.! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:03'!
classAt: aName ifAbsent: aBlock
	^ (environment at: aName ifAbsent: aBlock)
		ifNil: aBlock! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/31/2011 20:17'!
classDefinitionChangedFrom: oldClass to: newClass by: classModification
	self copyMethodsFrom: oldClass to: newClass using: classModification.
	" Copy over the trait composition "
	self copyTraitCompositionFrom: oldClass to: oldClass.
	" Copy over the method organization "
	newClass organization: oldClass organization.
	" Update the superclass links "
	oldClass superclass == newClass superclass ifFalse: [ 
		oldClass superclass removeSubclass: oldClass.
		newClass superclass addSubclass: newClass ].
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'CamilloBruni 3/30/2011 13:20'!
classFormatChangedFrom: oldClass to: newClass by: classModification
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 16:20'!
copyMethodsFrom: oldClass to: newClass using: classModification
	MethodFieldUpdater new 
		transformAll: oldClass methodDict 
		using: classModification methodModification
		to: newClass ! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 16:55'!
environment: anEnvironment
	environment := anEnvironment! !

!PharoClassInstaller methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/22/2011 17:43'!
initialize
	super initialize.
	environment := nil environment.! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:34'!
migrateClasses: old to: new using: anInstanceModification
	instanceModification := anInstanceModification.
	old size > 0 
		ifTrue: [ [
			1 to: old size do: [ :index |
				self updateClass: (old at: index) to: (new at: index)].
			old elementsForwardIdentityTo: new.
			" Garbage collect away the zombie instances left behind in garbage memory in #updateInstancesFrom: "
			" If we don't clean up this garbage, a second update would revive them with a wrong layout!! "
			" (newClass rather than oldClass, since they are now both newClass) "
			Smalltalk garbageCollect.
		] valueUnpreemptively ]! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 16:59'!
recategorize: aClass to: aCategory
	aClass category ~~ aCategory ifTrue: [
		environment organization classify: aClass name under: aCategory.
		self systemChangeNotifier class: aClass recategorizedFrom: aClass category to: aCategory ]! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 4/3/2011 11:26'!
shallowClassDefinitionChangedFrom: oldClass to: newClass by: classModification
	self shallowCopyMethodsFrom: oldClass to: newClass using: classModification.
	" Copy over the trait composition "
	self copyTraitCompositionFrom: oldClass to: oldClass.
	" Copy over the method organization "
	newClass organization: oldClass organization.
	" Update the superclass links "
	oldClass superclass == newClass superclass ifFalse: [ 
		oldClass superclass removeSubclass: oldClass.
		newClass superclass addSubclass: newClass ].
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:54'!
shallowCopyMethodsFrom: oldClass to: newClass using: classModification
	newClass methodDict: oldClass methodDict! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/31/2011 14:19'!
superclassChangedOf: aClass to: newClass by: classModification
	|oldClass|
	oldClass := aClass copy.
	aClass superclass removeSubclass: aClass.
	aClass superclass: newClass.
	newClass addSubclass: aClass.
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: aClass.! !

!PharoClassInstaller methodsFor: 'private' stamp: 'ToonVerwaest 3/22/2011 16:57'!
systemChangeNotifier
	^ SystemChangeNotifier uniqueInstance! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/23/2011 23:57'!
updateClass: oldClass to: newClass
	| compactClassIndex |
	compactClassIndex := oldClass indexIfCompact.
	compactClassIndex > 0
		ifTrue: [ newClass layout compactClassIndex: compactClassIndex ].
	self updateInstancesFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 19:32'!
updateInstancesFrom: old to: new
	| oldInstances variable instSize newInstances |
	oldInstances := old allInstances asArray.
	variable := new isVariable.
	instSize := new instSize.
	newInstances := Array new: oldInstances size.
	1 to: oldInstances size do:[:i|
		newInstances at: i put: (
			new newInstanceFrom: (oldInstances at: i) 
				 variable: variable 
				 size: instSize 
				 map: instanceModification)].
	oldInstances elementsForwardIdentityTo: newInstances.! !

Object subclass: #AbstractClassModification
	instanceVariableNames: 'target layout propagations newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractClassModification methodsFor: 'public' stamp: 'ToonVerwaest 4/1/2011 17:49'!
apply
	^ newClass := target shallowCopy
		superclass: self superclass
		layout: layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'CamilloBruni 3/30/2011 19:27'!
checkSanity
	layout checkSanity.! !

!AbstractClassModification methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:20'!
computeChange
	self checkSanity.! !

!AbstractClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 03:31'!
initialize
	propagations := OrderedCollection new.! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 13:50'!
layout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:07'!
layout: aLayout
	layout := aLayout.
	layout host: target.
	layout finalize.
	self computeChange! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:49'!
newClass
	^ newClass! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:24'!
newLayout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:38'!
oldLayout
	^ target layout! !

!AbstractClassModification methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:16'!
propagate
	target subclassesDo: [ :subclass |
		propagations add:
			(ClassModificationPropagation
				propagate: self
				to: subclass) ]
	
		! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:19'!
propagationsDo: aBlock
	propagations do: [ :aPropagation |
		aBlock value: aPropagation.
		aPropagation propagationsDo: aBlock ]! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 19:53'!
result
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:40'!
target
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/19/2011 15:57'!
target: aTarget
	target := aTarget! !

AbstractClassModification subclass: #ClassModification
	instanceVariableNames: 'ownSlotStart superclass additions removals changes subclassSlotOffset slotShift methodModification copies traitComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModification class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/31/2011 19:34'!
modify: aClass extend: aSuperclass withLayoutType: layoutClass slots: someSlots traitComposition: aTraitComposition
	^ ClassModification new
		target: aClass;
		superclass: aSuperclass;
		traitComposition: aTraitComposition;
		layoutType: layoutClass	slots: someSlots! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
additions: aCollection
	additions := aCollection! !

!ClassModification methodsFor: 'private' stamp: 'CamilloBruni 3/29/2011 19:00'!
buildModificationMapFor: aModification
	aModification slotShift: (ShiftedField new shift: slotShift).
	
	aModification size = 0 
		ifTrue: [ ^ aModification ].
	
	additions do: [ :slot | 
		self installSlotAddition: slot on: aModification].
	
	changes keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotChangeFrom: oldSlot to: newSlot on: aModification ].
	
	removals do: [ :slot | 
		self installSlotRemoval: slot on: aModification].
	
	copies keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotCopiedFrom: oldSlot to: newSlot on: aModification ].
	
	^ aModification! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:49'!
changes
	^ changes! !

!ClassModification methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:21'!
computeChange
	super computeChange.
	layout computeChangesFrom: target layout in: self.
	slotShift := layout fieldSize - target layout fieldSize.
	self propagate.! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:45'!
copies
	^ copies! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 02:00'!
formatChange
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 03:31'!
initialize
	super initialize.
	changes := IdentityDictionary new.
	copies := IdentityDictionary new.
	removals := {}.
	additions := {}.! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotAddition: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(AddedField new
			newSlot: slot;
			fieldIndex: idx) installOn: aModification  ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotChangeFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(ModifiedField new
			newSlot: newSlot;
			originalSlot: oldSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/30/2011 13:41'!
installSlotCopiedFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(UnmodifiedField new
			slot: newSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotRemoval: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(RemovedField new
			originalSlot: slot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:45'!
instanceModification
	| map |
	map := InstanceModification new: layout fieldSize.
	^ self buildModificationMapFor: map! !

!ClassModification methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:14'!
layoutType: layoutType slots: slotArray
	| parentLayout newScope |
	parentLayout := self parentLayout.
	newScope := parentLayout slotScope extend: slotArray.
	self layout: (layoutType buildFrom: parentLayout scope: newScope)! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:27'!
methodModification
	^ methodModification ifNil: [
		methodModification := MethodModification new: target layout fieldSize.
		self buildModificationMapFor: methodModification ]! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/31/2011 21:17'!
modifiesFormat
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/30/2011 15:31'!
modifiesSlots
	^ (changes isEmpty and: [ removals isEmpty and: [ additions isEmpty ]]) not! !

!ClassModification methodsFor: 'testing' stamp: 'CamilloBruni 3/24/2011 23:56'!
modifiesSuperclass
	^ (target superclass == superclass) not! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:04'!
newScope
	^ layout slotScope! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:03'!
originalScope
	^ target layout slotScope! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:15'!
parentLayout
	^ traitComposition composeWithLayout: self superLayout! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
removals: aCollection
	removals := aCollection! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 23:32'!
slotShift
	^ slotShift! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:25'!
subclassSlotOffset
	^ subclassSlotOffset! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:15'!
superLayout
	^ superclass
		ifNil: [ NilLayout instance ]
		ifNotNil: [ superclass layout ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:34'!
superclass
	^ superclass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:32'!
superclass: aClass
	superclass := aClass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 19:48'!
traitComposition
	^ traitComposition! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 20:54'!
traitComposition: aTraitComposition
	" We copy the trait composition since we might want "
	" to update the slot indices if the composition is partly stateful "
	traitComposition := aTraitComposition copyTraitExpression! !

AbstractClassModification subclass: #ClassModificationPropagation
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModificationPropagation class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 14:51'!
propagate: aModification to: aClass
	^ self new
		propagate: aModification
		to: aClass! !

!ClassModificationPropagation methodsFor: 'migrating' stamp: 'ToonVerwaest 3/27/2011 21:14'!
methodModification
	^ origin methodModification! !

!ClassModificationPropagation methodsFor: 'public' stamp: 'ToonVerwaest 4/1/2011 18:16'!
propagate: aModification to: aTarget
	origin := aModification.
	target := aTarget.
	self layout: (target layout reshapeFrom: origin oldLayout slotScope to: origin newLayout).! !

!ClassModificationPropagation methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:50'!
superclass
	^ origin newClass! !

Object subclass: #AbstractFieldModification
	instanceVariableNames: 'fieldIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex
	^ fieldIndex! !

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex: anObject
	fieldIndex := anObject! !

!AbstractFieldModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	self subclassResponsibility! !

!AbstractFieldModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance! !

!AbstractFieldModification methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 18:29'!
rewriteIR: aNode usingModification: aMethodModification! !

AbstractFieldModification subclass: #AddedField
	instanceVariableNames: 'newSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AddedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	aModification installAddedSlot: self! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
name
	^ newSlot name! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot
	^ newSlot! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot: anObject
	newSlot := anObject! !

AbstractFieldModification subclass: #ModifiedField
	instanceVariableNames: 'newSlot originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ModifiedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installModifiedSlot: self! !

!ModifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:54'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: self oldFieldIndex)! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot
	^ newSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot: anObject
	newSlot := anObject! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot

	^ originalSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #RemovedField
	instanceVariableNames: 'originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!RemovedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installRemovedSlot: self! !

!RemovedField methodsFor: 'runtime support' stamp: 'ToonVerwaest 3/28/2011 20:39'!
invalidRead
	self error: 'Trying to read from removed field: ', originalSlot name! !

!RemovedField methodsFor: 'runtime support' stamp: 'ToonVerwaest 3/28/2011 20:56'!
invalidWrite
	self error: 'Trying to write to removed field: ', originalSlot name! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot
	^ originalSlot! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #ShiftedField
	instanceVariableNames: 'shift'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ShiftedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance
	newInstance instVarAt: index put: (oldInstance instVarAt: index - shift)! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift
	^ shift! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift: anObject
	shift := anObject! !

AbstractFieldModification subclass: #UnmodifiedField
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:27'!
fieldIndex
	^ slot index + fieldIndex! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:28'!
installOn: aModification
	aModification installUnmodifiedSlot: self! !

!UnmodifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:55'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: index)! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot
	^ slot! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot: anObject
	slot := anObject! !

Object subclass: #AbstractLayout
	instanceVariableNames: 'host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/3/2011 22:58'!
allSlots
	^ {}! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:07'!
allVisibleSlots
	^ {}! !

!AbstractLayout methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 03:38'!
checkSanity
	host ifNil: [ self error: 'Host should not be nil' ].! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
fieldSize
	^ 0! !

!AbstractLayout methodsFor: 'finalization' stamp: 'ToonVerwaest 4/7/2011 12:08'!
finalize
	self allSlotsDo: [ :aSlot | aSlot finalize: self ]! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
hasFields
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
hasSlots
	^ false! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:52'!
host
	^ host! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:52'!
host: anObject
	host := anObject! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:38'!
instanceVariables
	^ {}! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isBits
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isVariable
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isWeak
	^ false! !

!AbstractLayout methodsFor: 'printing' stamp: 'ToonVerwaest 4/1/2011 03:39'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:10'!
resolveSlot: aName
	self flag: 'Signal rather than error'.
	self error: 'No slots found'! !

AbstractLayout subclass: #NilLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

NilLayout class
	instanceVariableNames: 'instance'!

NilLayout class
	instanceVariableNames: 'instance'!

!NilLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 15:29'!
instance
	^ instance ifNil: [ instance := self new ]! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:26'!
extend: someSlots
	^ PointerLayout new
		slotScope: (LayoutEmptyScope instance extend: someSlots)! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendByte
	^ ByteLayout new! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:26'!
extendVariable: someSlots
	^ VariableLayout new
		slotScope: (LayoutEmptyScope extend: someSlots)! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:57'!
extendWeak
	^ WeakLayout new! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendWord
	^ WordLayout new! !

!NilLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
fieldSize
	^ 0! !

!NilLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
hasFields
	^ false! !

!NilLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
hasSlots
	^ false! !

!NilLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 17:30'!
slotScope
	^ LayoutEmptyScope instance! !

AbstractLayout subclass: #ObjectLayout
	instanceVariableNames: 'compactClassIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

ObjectLayout subclass: #BitsLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!BitsLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:53'!
initializeInstance: anInstance! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:25'!
isBits
	^ true! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

BitsLayout subclass: #ByteLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!ByteLayout class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/4/2011 13:40'!
buildFrom: superLayout scope: aScope
	aScope hasFields 
		ifTrue: [ self error: 'No fields expected!!' ].
	^ superLayout extendByte! !

!ByteLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 8! !

BitsLayout subclass: #WordLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!WordLayout class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/4/2011 13:40'!
buildFrom: superLayout scope: aScope
	aScope hasFields 
		ifTrue: [ self error: 'No fields expected!!' ].
	^ superLayout extendWord! !

!WordLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 6! !

ObjectLayout subclass: #CompiledMethodLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!CompiledMethodLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 15:58'!
format
	^ 3586! !

!CompiledMethodLayout methodsFor: 'initialize-release' stamp: 'CamilloBruni 10/16/2011 20:21'!
initialize
	super initialize.
	self host: CompiledMethod.! !

ObjectLayout subclass: #LayoutWithSlots
	instanceVariableNames: 'slotScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:23'!
allSlots
	^ slotScope flatten! !

!LayoutWithSlots methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 01:54'!
allSlotsDo: aBlock
	slotScope allSlotsDo: aBlock! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/4/2011 13:30'!
allVisibleSlots
	^ slotScope allVisibleSlots! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'CamilloBruni 4/4/2011 13:20'!
atName: aName
	^ slotScope atName: aName! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'ToonVerwaest 4/1/2011 14:03'!
atName: aName ifAbsent: aBlock
	^ slotScope atName: aName ifAbsent: aBlock! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 02:02'!
checkSanity
	super checkSanity.
	self checkSlotNames.
	self checkSlotIndices.! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 02:43'!
checkSlotIndices
	| slots current |
	slots := slotScope flatten.
	[ slots size > 1 ] whileTrue: [
		current := slots removeFirst.
		self assert: slots first index = (current index + current size) ]! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/3/2011 16:01'!
checkSlotNames
	| slots current |
	slots := slotScope allVisibleSlots.
	[ slots isEmpty ] whileFalse: [
		current := slots removeLast.
		slots do: [ :other |
			other name == current name
				ifTrue: [ 
					SlotDuplicationConflict new
						oldSlot: current;
						newSlot: other;
						host: host;
						signal ]]]! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 4/7/2011 11:53'!
computeChangesFrom: other in: modification
	| additions changes removals copies |
	other hasSlots ifFalse: [ ^ modification additions: self allSlots asArray ].
	
	additions := self allSlots.
	removals := OrderedCollection new.
	copies := modification copies.
	changes := modification changes.
	
	other allSlots do: [ :oldSlot |
		(self popSlot: oldSlot from: additions)
			ifNil: [ removals add: oldSlot ]
			ifNotNil: [ :newSlot |
				newSlot = oldSlot
					ifTrue: [ copies at: newSlot put: oldSlot ]
					ifFalse: [ changes at: newSlot put: oldSlot ]]].
			
	modification
		additions: additions asArray;
		removals: removals asArray.! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'CamilloBruni 4/4/2011 15:39'!
extend: aScope
	^ self species new slotScope: aScope! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 03:25'!
extendAgain: aLayout with: someScope
	| result |
	result := aLayout copy.
	result slotScope: someScope.
	^ result! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:31'!
extendVariable: newScope
	^ VariableLayout new slotScope: newScope! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:31'!
extendWeak: newScope
	^ WeakLayout new slotScope: newScope! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:28'!
fieldSize
	^ slotScope fieldSize! !

!LayoutWithSlots methodsFor: 'forking' stamp: 'ToonVerwaest 4/2/2011 20:55'!
forkLayout: aLayout
	| forkScope |
	forkScope := slotScope forkScope: aLayout slotScope.
 	^ aLayout species buildFrom: self scope: forkScope! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:16'!
hasFields
	^ slotScope hasFields! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:25'!
hasSlots
	^ slotScope hasSlots! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'ToonVerwaest 4/1/2011 15:26'!
includesName: aName
	self atName: aName ifAbsent: [ ^ false ].
	^ true! !

!LayoutWithSlots methodsFor: 'instance initialization' stamp: 'ToonVerwaest 4/1/2011 01:54'!
initializeInstance: anInstance
	self allSlotsDo: [ :slot | slot initialize: anInstance ]! !

!LayoutWithSlots methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:33'!
instanceSpecification
	| base |
	base := self instanceSpecificationBase.
	^ self hasFields
		ifTrue: [ base + 1 ]
		ifFalse: [ base ]! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/4/2011 13:48'!
instanceVariables
	^ slotScope visibleSlotNames! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 4/1/2011 02:45'!
popSlot: aSlot from: collection
	collection withIndexDo: [ :slot :index |
		slot name == aSlot name
			ifTrue: [ ^ collection removeAt: index ]].
	^ nil! !

!LayoutWithSlots methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 21:00'!
postCopy
	slotScope := slotScope copy! !

!LayoutWithSlots methodsFor: 'printing' stamp: 'ToonVerwaest 4/1/2011 01:40'!
printSlotDefinitionOn: aStream
	slotScope printSlotDefinitionOn: aStream! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 18:16'!
reshapeFrom: oldScope to: newLayout
	| newScope |
	newScope := slotScope rebase: oldScope to: newLayout slotScope.
	^ newLayout extendAgain: self with: newScope.! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 17:24'!
reshapeTo: aModification
	| newScope |
	newScope := slotScope rebase: aModification originalScope to: aModification newScope.
	^ aModification newLayout extendAgain: self with: newScope.! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:10'!
resolveSlot: aName
	^ slotScope atName: aName! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:20'!
size 
	^ slotScope fieldSize! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 10/16/2011 20:12'!
slotAt: index
	self flag: 'clean..'.
	^ self allSlots at: index! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:13'!
slotScope
	^ slotScope! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:13'!
slotScope: anObject
	slotScope := anObject! !

LayoutWithSlots subclass: #PointerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!PointerLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 4/2/2011 17:24'!
buildFrom: superLayout scope: aScope
	^ superLayout extend: aScope! !

!PointerLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecificationBase
	^ 0! !

LayoutWithSlots subclass: #VariableLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!VariableLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 4/2/2011 17:24'!
buildFrom: superLayout scope: aScope
	^ superLayout extendVariable: aScope! !

!VariableLayout methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 02:55'!
extendAgain: aLayout with: someScope
	| result |
	result := self species new.
	result host: aLayout host.
	aLayout compactClassIndex > 0
		ifTrue: [ result compactClassIndex: aLayout compactClassIndex ].
	result slotScope: someScope.
	^ result! !

!VariableLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecificationBase
	^ 2! !

!VariableLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

LayoutWithSlots subclass: #WeakLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!WeakLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 4/2/2011 17:24'!
buildFrom: superLayout scope: aScope
	^ superLayout extendWeak: aScope! !

!WeakLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 4! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isWeak
	^ true! !

!ObjectLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 4/2/2011 17:24'!
buildFrom: superLayout scope: aScope
	self subclassResponsibility! !

!ObjectLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:35'!
compactClassIndex: anIndex
	compactClassIndex := anIndex.
	host setFormat: self format! !

!ObjectLayout methodsFor: 'diff' stamp: 'ToonVerwaest 4/1/2011 02:22'!
computeChangesFrom: other in: modification
	other hasSlots ifTrue: [
		modification removals: other allSlots asArray ]! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:25'!
extend: aScope
	PrimitiveTypeConflict new
		layout: self;
		subType: #slot;
		signal! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendByte
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #byte;
			signal ].
	^ ByteLayout new! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:26'!
extendVariable: aScope
	PrimitiveTypeConflict new
		layout: self;
		subType: #variable;
		signal! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendWord
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #word;
			signal ].
	^ WordLayout new! !

!ObjectLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:34'!
format
	| fieldSize sizeHiBits format |
	fieldSize := self fieldSize + 1.
	sizeHiBits := fieldSize // 64.
	format := sizeHiBits.
	format := (format bitShift: 5) + compactClassIndex.
	format := (format bitShift: 4) + self instanceSpecification.
	format := (format bitShift: 6) + (fieldSize \\ 64).
	format := (format bitShift: 1).
	^ format! !

!ObjectLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:34'!
initialize
	compactClassIndex := 0! !

!ObjectLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:53'!
initializeInstance: anInstance
	self subclassResponsibility! !

!ObjectLayout methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/2/2011 17:26'!
reshapeTo: aModification
	^ self class buildFrom: aModification layout scope: LayoutEmptyScope instance! !

ObjectLayout subclass: #SmallIntegerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!SmallIntegerLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:32'!
extend: newScope
	^ PointerLayout new slotScope: newScope! !

!SmallIntegerLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 04:12'!
format
	^ 2! !

!SmallIntegerLayout methodsFor: 'initialize-release' stamp: 'CamilloBruni 10/16/2011 20:21'!
initialize
	super initialize.
	self host: SmallInteger.! !

!SmallIntegerLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 17:32'!
slotScope
	^ LayoutEmptyScope instance! !

Object subclass: #AbstractModification
	instanceVariableNames: 'slotShift modificationMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractModification class methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/24/2011 12:17'!
new: anInteger
	^ self new initialize: anInteger ! !

!AbstractModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:46'!
initialize: anInteger
	self initialize.
	modificationMap := Array new: anInteger.! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installAddedSlot: addedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installModifiedSlot: modifiedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installRemovedSlot: removedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:29'!
installUnmodifiedSlot: unmodifiedSlot
	modificationMap
		at: unmodifiedSlot fieldIndex
		put: unmodifiedSlot! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/30/2011 13:52'!
modificationAt: idx
	idx > modificationMap size 
		ifTrue: [ ^ slotShift ].
	^ modificationMap at: idx! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 12:18'!
size
	^ modificationMap size.! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 11:37'!
slotShift: aShift
	slotShift := aShift! !

AbstractModification subclass: #InstanceModification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:13'!
installAddedSlot: addedSlot
	modificationMap at: addedSlot newFieldIndex put: addedSlot! !

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot newFieldIndex put: modifiedSlot! !

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installRemovedSlot: removedSlot
	" ignore "! !

AbstractModification subclass: #MethodModification
	instanceVariableNames: 'addedSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!MethodModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:06'!
addedSlotNamed: name ifAbsent: aBlock
	^ addedSlots at: name ifAbsent: aBlock! !

!MethodModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:47'!
initialize
	addedSlots := Dictionary new! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
installAddedSlot: addedSlot
	addedSlots at: addedSlot name put: addedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot oldFieldIndex put: modifiedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installRemovedSlot: removedSlot
	modificationMap at: removedSlot oldFieldIndex put: removedSlot! !

Object subclass: #LayoutAbstractScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:27'!
allSlotsDo: aBlock
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 13:03'!
atName: aName
	^ self atName: aName ifAbsent: [ SlotNotFound signalForName: aName ].! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 14:04'!
atName: aName ifAbsent: aBlock
	self allSlotsDo: [ :slot | 
		slot name == aName ifTrue: [ ^ slot ]].
	^ aBlock value! !

!LayoutAbstractScope methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:25'!
extend: someSlots
	^ self extend: someSlots as: LayoutClassScope! !

!LayoutAbstractScope methodsFor: 'extending' stamp: 'CamilloBruni 4/6/2011 14:28'!
extend: someSlots as: type
	| scope fieldIndex currentParentScope nextParentScope |
	scope := type new: someSlots size.
	fieldIndex := self firstFieldIndex.
	currentParentScope := self.
	
	someSlots withIndexDo: [ :slot :slotIndex | |realSlot|
		realSlot := slot asSlot.
		nextParentScope := realSlot parentScopeFor: currentParentScope.
		nextParentScope == currentParentScope
			ifFalse: [
				currentParentScope := nextParentScope.
				fieldIndex := fieldIndex + currentParentScope ownFieldSize].
		realSlot index: fieldIndex.
		fieldIndex := fieldIndex + realSlot size.
		scope at: slotIndex put: realSlot ].
	
	scope parentScope: currentParentScope.
	^ scope! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:27'!
fieldSize
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:33'!
firstFieldIndex
	^ self fieldSize + 1! !

!LayoutAbstractScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 14:28'!
flatten
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'forking' stamp: 'ToonVerwaest 4/2/2011 18:25'!
forkScope: aScope
	^ LayoutForkScope new
		parentScope: self;
		forkScope: aScope! !

!LayoutAbstractScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
hasFields
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
hasSlots
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:25'!
ownFieldSize
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
printSlotDefinitionOn: aStream
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 02:58'!
rebase: originalLayout to: newLayout
	self error: 'Should not happen'! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:50'!
visibleSlotNames
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	self subclassResponsibility! !

LayoutAbstractScope variableSubclass: #LayoutClassScope
	instanceVariableNames: 'parentScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutClassScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 02:11'!
allSlotsDo: aBlock
	parentScope allSlotsDo: aBlock.
	self do: aBlock! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	self reverseDo: aBlock.
	parentScope allSlotsReverseDo: aBlock.! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 12:48'!
allVisibleSlots
	| result |
	result := parentScope allVisibleSlots.
	self do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot ]].
	^ result! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 02:10'!
do: aBlock
	1 to: self size do: [ :index |
		aBlock value: (self at: index) ]! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:25'!
fieldSize
	^ parentScope fieldSize + self ownFieldSize.! !

!LayoutClassScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/1/2011 01:56'!
flatten
	| result |
	result := parentScope flatten.
	result addAll: self.
	^ result! !

!LayoutClassScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 12:48'!
hasFields
	self do: [ :slot | 
		slot size > 0 
			ifTrue: [ ^ true ]].
	^ parentScope hasFields! !

!LayoutClassScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 12:48'!
hasSlots
	self size > 0 
		ifTrue: [ ^ true ].
	^ parentScope hasSlots! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:26'!
ownFieldSize
	|result|
	result := 0.
	self do: [ :slot | result := result + slot size ].
	^ result! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:24'!
parentScope: anObject
	parentScope := anObject! !

!LayoutClassScope methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 18:26'!
postCopy
	parentScope := parentScope copy.
	1 to: self size do: [ :index | 
		self at: index put: (self at: index) copy ]! !

!LayoutClassScope methodsFor: 'printing' stamp: 'CamilloBruni 4/4/2011 12:48'!
printSlotDefinitionOn: aStream
	| printedAtLeastOnSlot |
	
	aStream << '{'.
	
	printedAtLeastOnSlot := false.
	
	self do: [ :slot |
		slot isVisible
			ifTrue: [
				aStream lf; tab; tab; store: slot; << '.'.
				printedAtLeastOnSlot := true.]].
			
	printedAtLeastOnSlot 
		ifTrue: [ aStream lf; tab ].
	
	aStream << '}'.! !

!LayoutClassScope methodsFor: 'reshaping' stamp: 'CamilloBruni 4/4/2011 18:16'!
rebase: originalLayout to: newLayout
	| newParent result fieldIndex |
	newParent := parentScope == originalLayout
		ifTrue: [ newLayout ]
		ifFalse: [ parentScope rebase: originalLayout to: newLayout ].
		
	result := self copy.
	result parentScope: newParent.
	
	fieldIndex := newParent firstFieldIndex.
	result do: [ :slot | 
		slot index: fieldIndex.
		fieldIndex := fieldIndex + slot size ].
	
	^ result
	! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:49'!
reverseDo: aBlock
	|size|
	size := self size.
	1 to: size do: [ :index |
		aBlock value: (self at: (1 + size - index)) ]! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 12:48'!
visibleSlotNames
	| result |
	result := OrderedCollection new.
	self do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot name ]].
	^ result asArray! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 10/16/2011 20:08'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

!LayoutClassScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

LayoutAbstractScope subclass: #LayoutEmptyScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

LayoutEmptyScope class
	instanceVariableNames: 'instance'!

LayoutEmptyScope class
	instanceVariableNames: 'instance'!

!LayoutEmptyScope class methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:31'!
instance
	^ instance ifNil: [ instance := self new ]! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:32'!
allSlotsDo: aBlock! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:08'!
allVisibleSlots
	^ OrderedCollection new! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:31'!
fieldSize
	^ 0! !

!LayoutEmptyScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 14:32'!
flatten
	^ OrderedCollection new! !

!LayoutEmptyScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
hasFields
	^ false! !

!LayoutEmptyScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
hasSlots
	^ false! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:26'!
ownFieldSize
	^ 0! !

!LayoutEmptyScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:11'!
visibleSlotNames
	^ {}! !

!LayoutEmptyScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	aBlock value: self.! !

LayoutAbstractScope subclass: #LayoutForkScope
	instanceVariableNames: 'parentScope sideScopes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutForkScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:42'!
allSlotsDo: aBlock
	^ parentScope allSlotsDo: aBlock! !

!LayoutForkScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	^ parentScope allSlotsReverseDo: aBlock! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:08'!
allVisibleSlots
	^ parentScope allVisibleSlots! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:22'!
fieldSize
	| size |
	size := parentScope fieldSize.
	sideScopes do: [ :aScope | size := size + aScope fieldSize ].
	^ size! !

!LayoutForkScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 18:22'!
flatten
	| result |
	result := parentScope flatten.
	sideScopes do: [ :aScope | result addAll: aScope flatten ].
	^ result! !

!LayoutForkScope methodsFor: 'forking' stamp: 'CamilloBruni 4/4/2011 18:16'!
forkScope: aScope
	| fieldIndex |
	fieldIndex := self firstFieldIndex.
	aScope allSlotsDo: [ :aSlot |
		aSlot index: fieldIndex.
		fieldIndex := fieldIndex + aSlot size ].
	sideScopes := sideScopes copyWith: aScope.! !

!LayoutForkScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:42'!
hasFields
	^ parentScope hasFields! !

!LayoutForkScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 18:24'!
hasSlots
	parentScope hasSlots ifTrue: [ ^ true ].
	sideScopes do: [ :aScope | aScope hasSlots ifTrue: [ ^ true ]].
	^ false! !

!LayoutForkScope methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/2/2011 18:26'!
initialize
	sideScopes := {}! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:27'!
ownFieldSize
	self flag: 'might be rather the size of the sidescopes...'.
	^ 0! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:53'!
parentScope: anObject
	parentScope := anObject! !

!LayoutForkScope methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 18:30'!
postCopy
	| newSideScopes |
	parentScope := parentScope copy.
	newSideScopes := Array new: sideScopes size.
 	sideScopes withIndexDo: [ :aScope :anIndex | newSideScopes at: anIndex put: aScope copy ].
	sideScopes := newSideScopes.! !

!LayoutForkScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:42'!
printSlotDefinitionOn: aStream
	^ parentScope printSlotDefinitionOn: aStream! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:53'!
sideScopes
	^ sideScopes! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:53'!
sideScopes: anObject
	sideScopes := anObject! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:58'!
visibleSlotNames
	^ {}! !

!LayoutForkScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:32'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

LayoutAbstractScope subclass: #SlotAddingScope
	instanceVariableNames: 'parentScope slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

SlotAddingScope subclass: #BitFieldScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!BitFieldScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 22:01'!
bitField
	^ slots first! !

!BitFieldScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:10'!
initialize
	super initialize.
	slots := Array with: (BitFieldHolderSlot new)! !

!BitFieldScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 21:56'!
isFull
	^ self bitField isFull! !

SlotAddingScope subclass: #PropertyScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!PropertyScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:09'!
initialize
	super initialize.
	slots := Array with: (PropertyHolderSlot new)! !

!PropertyScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 22:01'!
propertyHolder
	^ slots first! !

!SlotAddingScope class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:43'!
withParent: aScope
	^ self new
		parentScope: aScope;
		yourself! !

!SlotAddingScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:07'!
allSlotsDo: aBlock
	parentScope allSlotsDo: aBlock.
	slots do: aBlock.! !

!SlotAddingScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:07'!
allSlotsReverseDo: aBlock
	slots reverseDo: aBlock.
	parentScope allSlotsReverseDo: aBlock.! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:07'!
allVisibleSlots
	| result |
	result := parentScope allVisibleSlots.
	slots do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot ]].
	^ result! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:27'!
fieldSize
	^ parentScope fieldSize + self ownFieldSize! !

!SlotAddingScope methodsFor: 'flattening' stamp: 'CamilloBruni 4/4/2011 18:07'!
flatten
	| result |
	result := parentScope flatten.
	result addAll: slots.
	^ result! !

!SlotAddingScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 18:07'!
hasFields
	slots do: [ :slot | 
		slot size > 0 
			ifTrue: [ ^ true ]].
	^ parentScope hasFields! !

!SlotAddingScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 18:07'!
hasSlots
	slots size > 0 
		ifTrue: [ ^ true ].
	^ parentScope hasSlots! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:28'!
ownFieldSize
	| result |
	result := 0.
	slots do: [ :slot | 
		result := result + slot size ].
	^ result! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 22:01'!
parentScope: aScope
	| fieldIndex |
	parentScope := aScope.
	fieldIndex := aScope firstFieldIndex.
	slots do: [ :slot|
		slot index: fieldIndex.
		fieldIndex := fieldIndex + slot size].! !

!SlotAddingScope methodsFor: 'copying' stamp: 'CamilloBruni 4/4/2011 18:07'!
postCopy
	parentScope := parentScope copy.
	1 to: slots size do: [ :index | 
		self at: index put: (slots at: index) copy ]! !

!SlotAddingScope methodsFor: 'printing' stamp: 'CamilloBruni 4/4/2011 18:12'!
printSlotDefinitionOn: aStream

	^ parentScope printSlotDefinitionOn: aStream! !

!SlotAddingScope methodsFor: 'reshaping' stamp: 'CamilloBruni 4/4/2011 18:11'!
rebase: originalLayout to: newLayout
	self halt.
	! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:08'!
visibleSlotNames
	| result |
	result := OrderedCollection new.
	slots do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot name ]].
	^ result asArray! !

!SlotAddingScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:33'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

!Object methodsFor: '*Slot' stamp: 'CamilloBruni 3/24/2011 14:50'!
ensureNilOrType: aClass
	self = nil
		ifTrue: [ ^ self ].
	(self isKindOf: aClass)
		ifFalse: [ (InvalidType has: self expected: aClass) signal].! !

!Object methodsFor: '*Slot' stamp: 'CamilloBruni 3/23/2011 14:23'!
ensureType: aClass
	(self isKindOf: aClass)
		ifFalse: [ (InvalidType has: self expected: aClass) signal].! !

Object subclass: #Slot
	instanceVariableNames: 'index name uninitializedValue modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Slot'!

!Slot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 16:40'!
asSlot
	^ self new! !

!Slot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 16:35'!
named: aSymbol
	^ self new
		name: aSymbol;
		yourself! !

!Slot methodsFor: 'comparing' stamp: 'CamilloBruni 3/30/2011 18:47'!
= other
	self == other
		ifTrue: [ ^ true ].
	^ ((self species == other species) 
			and: [ index = other index ])
			and: [ name = other name]! !

!Slot methodsFor: 'converting' stamp: 'CAmi 3/15/2011 14:34'!
asSlot
	^ self! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:47'!
compileInitialize: aClass
	"nothing to do"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 15:30'!
compileRawRead: aClass
	^ self variableNodeForClass: aClass! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileRawWrite: aNode to: aClass
	"^ ``(`,(self variableNodeForClass: aClass) := `,aNode) "! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
compileRead: aClass
	^ self compileRawRead: aClass! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ self compileRawWrite: aNode value to: aClass"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 16:55'!
finalize: layout
	"nothing to do here"! !

!Slot methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 15:01'!
index
	^ index! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:16'!
index: anIndex
	index := anIndex! !

!Slot methodsFor: 'initialization' stamp: 'CamilloBruni 3/10/2011 17:17'!
initialize: instance
	"nothing to do for the default slot"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/14/2011 19:42'!
inline
	^ self class == Slot! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:48'!
internalRead: anObject
	^ anObject instVarAt: index! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:48'!
internalWrite: aValue to: anObject
	anObject instVarAt: index put: aValue.! !

!Slot methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 18:46'!
isVisible
	^ true! !

!Slot methodsFor: 'testing' stamp: 'CamilloBruni 3/10/2011 15:01'!
name
	^ name! !

!Slot methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 16:16'!
name: aSymbol
	aSymbol ensureType: Symbol.
	name := aSymbol! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:38'!
needsField
	^ true! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:41'!
parentScopeFor: aScope
	^ aScope! !

!Slot methodsFor: 'printing' stamp: 'CamilloBruni 3/30/2011 15:37'!
printOn: aStream
	aStream << self name << ' => '; << self class name.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
read: anObject
	^ self internalRead: anObject! !

!Slot methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 14:32'!
size
	^ 1! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:59'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name! !

!Slot methodsFor: 'printing' stamp: 'CamilloBruni 3/29/2011 16:36'!
storeOn: aStream
	aStream store: self name.
	aStream nextPutAll: ' => '.
	self storeInitializationOn: aStream.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/2/2011 19:04'!
variableNodeForClass: aClass
	^ RBVariableNode named: name! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
write: aValue to: anObject
	self internalWrite: aValue to: anObject! !

Object subclass: #SlotClassBuilder
	instanceVariableNames: 'client oldClasses newClasses classSlots globals category superclass name layoutClass slots traitComposition classTraitComposition result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:27'!
apply: classModification
	classModification modifiesSlots
		ifTrue: [self applySlotChange: classModification]
		ifFalse: [ 
			classModification modifiesFormat
				ifTrue: [ self applyFormatChange: classModification]
				ifFalse: [
					classModification modifiesSuperclass
						ifTrue: [ self applySuperclassChange: classModification ]
						ifFalse: [ ^ self installTraitComposition: classModification ]]].
	
	client
		migrateClasses: oldClasses asArray
		to: newClasses asArray
		using: classModification instanceModification.
	
	self installTraitComposition: classModification.
		
	oldClasses removeAll.
	newClasses removeAll.! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:26'!
applyAndNotify: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client shallowClassDefinitionChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:41'!
applyAndUpdateFormat: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client classFormatChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/31/2011 19:56'!
applyAndUpdateMethods: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client classDefinitionChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applyFormatChange: classModification
	result := self applyAndUpdateFormat: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateFormat: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applyPropagations: classModification
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateMethods: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applySlotChange: classModification
	result := self applyAndUpdateMethods: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateMethods: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:27'!
applySuperclassChange: classModification
	result := self applyAndNotify: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndNotify: propagation ]! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/2/2011 14:37'!
build
	| oldClass metaChange classChange |
	result := oldClass := client classAt: name ifAbsent: [ ^ self buildNewClass ].

	self validateSuperChain: oldClass.
	
	metaChange := ClassModification
							modify: oldClass class
							extend: self metaOfSuper
							withLayoutType: PointerLayout
							slots: classSlots
							traitComposition: classTraitComposition.
	
	classChange := ClassModification
							modify: oldClass
							extend: superclass
							withLayoutType: layoutClass
							slots: slots
							traitComposition: traitComposition.
	
	self apply: metaChange.
	self apply: classChange.

	result isMeta ifFalse: [
		client recategorize: result to: category ].
	
	^ result! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 15:57'!
buildNewClass
	| metaclass newClass |
	metaclass := Metaclass new.
	metaclass
		superclass: self metaOfSuper
		withLayoutType: PointerLayout
		slots: classSlots.

	newClass := metaclass new.
	newClass setName: name.
	
	newClass
		superclass: superclass
		withLayoutType: layoutClass
		slots: slots.
			
	client classAdded: newClass inCategory: category.
	
	^ newClass! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
category: aCategory
	category := aCategory! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
classSlots: someClassSlots
	classSlots := someClassSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 20:53'!
classTraitComposition: aTraitComposition
	classTraitComposition := aTraitComposition asTraitComposition! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
client: aClient
	client := aClient! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
globals: globalsArray
	globals := globalsArray! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/31/2011 23:11'!
initialize
	oldClasses := OrderedCollection new.
	newClasses := OrderedCollection new.
	globals := {}.
	classSlots := {}.
	slots := {}.
	layoutClass := PointerLayout.
	superclass := Object.
	classTraitComposition := NilTraitComposition instance.
	traitComposition := NilTraitComposition instance.! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/31/2011 21:14'!
installTraitComposition: classModification
	client
		installTraitComposition: classModification traitComposition
		on: result! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
layoutClass: aLayoutClass
	layoutClass := aLayoutClass! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
metaOfSuper
	 ^ superclass ifNil: [ Class ] ifNotNil: [ superclass class ].! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
name: aName
	name := aName.
	self validateClassName.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
slots: someSlots
	slots := someSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
superclass: aSuperclass
	superclass := aSuperclass.
	superclass ifNotNil: [ self validateClass: superclass ].
	client environment: superclass environment! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 20:09'!
traitComposition: aTraitComposition
	traitComposition := aTraitComposition asTraitComposition! !

!SlotClassBuilder methodsFor: 'validating' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateClass: aClass
	aClass isBehavior
		ifFalse: [ self error: 'Trying to build classes from non-class objects' ].
	aClass isMeta
		ifTrue: [ self error: 'Metaclasses cannot be used for building classes' ].! !

!SlotClassBuilder methodsFor: 'validating' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateClassName
	name isSymbol ifFalse: [
		self error: 'Class name should be a symbol.' ].
	name first canBeGlobalVarInitial ifFalse: [
		self error: 'Class name does not start with a valid Global Var Initial.' ].! !

!SlotClassBuilder methodsFor: 'validating' stamp: 'ToonVerwaest 3/31/2011 20:03'!
validateSuperChain: oldClass
	superclass ifNil: [ ^ nil ].
	superclass withAllSuperclassesDo: [ :class |
		class == oldClass
			ifTrue: [ self error: 'Trying to build a circular hierarchy' ]].! !

Object subclass: #SlotLayoutBuilder
	instanceVariableNames: 'slots layoutClass slotScope host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-LayoutBuilder'!

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:30'!
make: aBlock
	|builder|
	builder := self new.
	aBlock value: builder.
	^ builder build! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:02'!
make: aBlock layout: aLayoutClass
	^ self make: [ :builder|
		builder layout: aLayoutClass.
		aBlock value: builder.
	]! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:02'!
makeByte: aBlock
	^ self make: aBlock layout: ByteLayout! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:00'!
makeVariable: aBlock
	^ self make: aBlock layout: VariableLayout! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:02'!
makeWord: aBlock
	^ self make: aBlock layout: WordLayout! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:21'!
addSlots: aCollection
	aCollection do: [ :slot|
		self slot: slot].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 16:43'!
atIndex: index ifAbsent: aBlock
	index = 0
		ifFalse: [ ^ slots at: index].
	^ aBlock value.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:06'!
build
	|layout|
	self checkPreconditions.
	self finalizeSlots.
	layout := self buildLayout.
	self ensureUniqueSlotNames.
	^ layout.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:48'!
buildLayout
	| layout |
	layout := layoutClass new.
	layout slotScope: self buildSlotScope.
	^ layout.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:47'!
buildSlotScope
	^ slotScope extend: slots asArray.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:05'!
checkPreconditions
	layoutClass ifNil: [ self error: 'No layout class specified' ].
	slotScope ifNil: [ self error: 'No slot scope specified' ].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:43'!
ensureUniqeParentSlotName: aSlot
	slotScope allSlotsDo: [:slot|
		slot name == aSlot name
			ifTrue: [
				SlotDuplicationConflict new 
					newSlot: aSlot;
					oldSlot: slot;
					signal]]! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:42'!
ensureUniqueSlotName: aSlot
	aSlot isVisible 
		ifFalse: [ ^ self].
	^ self ensureUniqueSlotName: aSlot startingAt: 1.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:42'!
ensureUniqueSlotName: aSlot startingAt: start
	|slot|
	self ensureUniqeParentSlotName: aSlot.
	start to: slots size do: [:index|
		slot := slots at: index.
		slot name == aSlot name
			ifTrue: [
				SlotDuplicationConflict new 
					newSlot: aSlot;
					oldSlot: slot;
					signal]]! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:40'!
ensureUniqueSlotNames
	slots withIndexDo: [ :slot  :index |
		self ensureUniqueSlotName: slot startingAt: index + 1].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:32'!
finalizeSlots
	slots do: [ :slot| 
		slot finalize: self].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:31'!
findFirstSlot: aConditionBlock ifAbsent: aBlock
	slotScope allSlotsDo: [:slot|
			(aConditionBlock value: slot)
				ifTrue: [ ^ slot ]].
	^ self atIndex: (slots findFirst: aConditionBlock) ifAbsent: aBlock.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:32'!
findFirstSlotNamed: name
	^ self findFirstSlot: [:slot| slot name == name] 
			 ifAbsent: [ SlotNotFound signalForName: name]! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:31'!
findLastSlot: aConditionBlock ifAbsent: aBlock
	slotScope allSlotsReverseDo: [:slot|
			(aConditionBlock value: slot)
				ifTrue: [ ^ slot ]].
	^ self atIndex: (slots findLast: aConditionBlock) ifAbsent: aBlock.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:16'!
host 
	^ host! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:15'!
host: aClass 
	host := aClass! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:21'!
initialize
	slots := OrderedCollection new.
	layoutClass := PointerLayout.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:37'!
layout: aLayoutClass
	layoutClass := aLayoutClass.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:51'!
resolveSlot: slotOrSymbol
	(slotOrSymbol isKindOf: Slot)
		ifTrue: [ ^ slotOrSymbol ].
	^ self findFirstSlotNamed: slotOrSymbol! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:44'!
scope: aSlotScope
	slotScope := aSlotScope.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 16:10'!
slot: aSlot
	|newSlot|
	newSlot := aSlot asSlot.
	self ensureUniqueSlotName: newSlot.
	slots add: newSlot.
	^ aSlot.! !

Object subclass: #SlotTestObject
	instanceVariableNames: 'field'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Slot-Test'!

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:01'!
field
	^ field! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:01'!
field: aValue
	field := aValue! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/28/2012 16:01'!
definition
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 800) writeStream.
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [aStream nextPutAll: superclass name].
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: self category asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 10/18/2011 15:10'!
initializeLayout
	(self allInstVarNames includes: #layout) 
		ifFalse: [ ^ self ].
		
	layout isNil ifFalse: [ ^ self ].
	
	self superclass isNil 
		ifFalse: [ self superclass initializeLayout ].
	
	layout := SlotVirus newLayoutFor: self! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 18:33'!
initializeLayoutWithSlots: slots
	| offset superlayout|
	superlayout := superclass layout.
	offset := superlayout size.
	
	"create the new layout and copy in the super slots"
	layout := self layoutSized: slots size + offset.
	layout replaceFrom: 1 to: offset with: superlayout.
	
	"create new slots"
	slots withIndexDo: [ :slot :index|
		layout at: offset + index put: slot asSlot].
	layout finalize.
	
	"backup solution to create instvar names"
	instanceVariables := Array new: slots size.
	1 to: slots size do: [ :index| 
		instanceVariables at: index put: (layout at: index + offset) name].! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/14/2011 19:37'!
layout
	^ layout! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 3/30/2011 19:21'!
layoutSized: size
	|layoutInstance layoutClass|
	layoutClass := PointerLayout.
	
	self isBits
		ifTrue: [
			self isBytes
				ifTrue: [ layoutClass := ByteLayout ].
			self isWords 
				ifTrue: [ layoutClass := WordLayout ]]
		ifFalse: [
			self isVariable ifTrue: [ layoutClass := VariableLayout ].
			self isWeak ifTrue: [ layoutClass := WeakLayout ]].
	
	layoutInstance := layoutClass new: size.
	layoutInstance host: self.
	
	^ layoutInstance! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/28/2012 15:37'!
slotDefinition
	"Answer a String that defines the receiver."
 	
	| aStream |
	layout ifNil: [ ^ self slotlessDefinition ].
	aStream := (String new: 300) writeStream.
	aStream store: self.
	^ aStream contents! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/18/2011 12:42'!
slotDefinitionOn: aStream
	layout printSlotDefinitionOn: aStream.! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/28/2012 15:38'!
slotStoreOn: aStream
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [aStream nextPutAll: superclass name].
		
	aStream << ' subclass: '; store: self name.
	
	aStream lf; tab; << 'layout: '; << self layout class name .
			
	(self hasTraitComposition and: [self traitComposition notEmpty]) 
		ifTrue: [aStream cr; tab. aStream << 'uses: ' << self traitCompositionString].
		
	aStream lf; tab; << 'slots: '.
	self slotDefinitionOn: aStream.
			
	aStream lf; tab; << 'classSlots: '.
	self class slotDefinitionOn: aStream.
			
	aStream lf; tab; << 'globals: ';
		store: self sharedPoolsString.
			
	aStream lf; tab; << 'category: '; 
		print: (SystemOrganization categoryOfElement: self name).

	superclass ifNil: [ 
		aStream nextPutAll: '.'; lf.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'].! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 10/18/2011 15:19'!
slotlessDefinition
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 300) writeStream.
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [aStream nextPutAll: superclass name].
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition and: [self traitComposition notEmpty]) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: (self environment organization categoryOfElement: self name) asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 3/25/2011 00:40'!
subclass: className layout: aLayoutClass slots: slotCollection classSlots: classSlotCollection globals: poolDictString category: categoryName
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	^ PharoClassInstaller make: [:builder|
		builder
			superclass: self;
			name: className;
			layoutClass: aLayoutClass;
			classSlots: classSlotCollection;
			category: categoryName;
			globals: poolDictString;
			slots: slotCollection
		]
		
! !
